#include "stdafx.h"

char * g_szFeedbackTitle = "Feedback Configuration";

class CVwFeedback : public CDialog { 
	public : 
		CFeedback * m_pFeedback;

		//-- dialog controls 
		CDlgCombo m_cmbType;
		CDlgEdit m_edtKp;		
		CDlgEdit m_edtKi;		
		CDlgEdit m_edtKd;		
		CDlgEdit m_edtKiWindow;		
		CDlgEdit m_edtName;
				
		//-- Initialize controls - fill hdw list and set controls to empty values or passed setup
		void InitializeControls( ) {
			m_cmbType.SetHandle( GetDlgItem( m_hDlg, IDC_CMBTYPE ), "" );
			m_edtKp.SetHandle( GetDlgItem( m_hDlg, IDC_EDTKP ), "" );		
			m_edtKi.SetHandle( GetDlgItem( m_hDlg, IDC_EDTKI ), "" );		
			m_edtKd.SetHandle( GetDlgItem( m_hDlg, IDC_EDTKD ), "" );		
			m_edtKiWindow.SetHandle( GetDlgItem( m_hDlg, IDC_EDTKIWINDOW ), "" );	
			m_edtName.SetHandle( GetDlgItem( m_hDlg, IDC_EDTNAME ), "" );
			m_cmbType.ClearContents();
			m_cmbType.AddString("PID");
			}
			
		void Setup( ) { 
			CPID * pPID = (CPID *)m_pFeedback;
			m_cmbType.SetCurSel( 0 );
			m_edtKp.SetTextDouble( pPID->m_dKp );
			m_edtKi.SetTextDouble( pPID->m_dKi );
			m_edtKd.SetTextDouble( pPID->m_dKd );
			m_edtKiWindow.SetTextInt( pPID->m_iQueueSize );
			m_edtName.SetText( pPID->m_cName.ConstBuffer() );
			}
		
		void Teardown( ) { 
			CPID * pPID = (CPID *)m_pFeedback;
			pPID->m_dKp = m_edtKp.GetTextDouble( );
			pPID->m_dKi = m_edtKi.GetTextDouble( );
			pPID->m_dKd = m_edtKd.GetTextDouble( );
			pPID->m_iQueueSize = m_edtKiWindow.GetTextInt(  );
			m_edtName.GetText( &(pPID->m_cName) );
			}

		//-----------------------------------------------------------------------------
		// Events and messages 
		
		//-- Delete : Confirm, then return IDYES
		void OnBtnDelete() { 
			if( IDYES==MessageBox( GetParent( m_hDlg ), "Delete this configuration ?", g_szFeedbackTitle, MB_YESNO ) ) 
				EndDialog( m_hDlg, IDYES );
			}
			
		//-- OK : Get control data then return IDOK
		void OnBtnOK() { 
			Teardown( );
			EndDialog( m_hDlg, IDOK );
			}

		//-- Cancel : Return IDCANCEL
		void OnBtnCancel() { 
			EndDialog( m_hDlg, IDCANCEL );
			}
			
	};

CVwFeedback * g_pVwFeedback;		// Modal - one and only instance
	
//-----------------------------------------------------------------------------
// Message Pump
BOOL CALLBACK FeedbackDlgProc( HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam) { 
	int wmId, wmEvent;
	
	switch( iMsg ) { 
		//----- DIALOG INIT -  Control Initialization
		case WM_INITDIALOG :	
			g_pVwFeedback = new CVwFeedback;
			g_pVwFeedback->m_pFeedback=(CFeedback *)lParam;
			g_pVwFeedback->m_hDlg=hDlg;			
			g_pVwFeedback->InitializeControls();
			g_pVwFeedback->Setup( );
			return TRUE;

		//----- MENU and CONTROL Commands
		case WM_COMMAND : 
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			switch( wmId ) { 
				case IDC_BTNDELETE :				//-- [Delete]
					g_pVwFeedback->OnBtnDelete();
					break;
					
				case IDCANCEL :						//-- [Cancel]
					g_pVwFeedback->OnBtnCancel();
					break;
					
				case IDOK :							//-- [OK]
					g_pVwFeedback->OnBtnOK();
					break;
				}
			return TRUE;

		case WM_PAINT :
			/*		
			PAINTSTRUCT ps; 
			HDC hdc = BeginPaint(hDlg, &ps); 
			...extra drawing... 
			EndPaint(hDlg, &ps); 
			*/
			return false;

		case WM_DESTROY : 
			delete g_pVwFeedback;
			SetWindowLong( GetParent( hDlg ), 0, 0);
			return TRUE;
			
		default : 
			break;
		}
	return FALSE;
	} 

